<?php
/* htmlbeauty.php
 *
 * Copyright (C) 2016 Ing. Stefano Salvi<stefano@salvi.mn.it>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

function htmlColor ($t){
    return preg_replace (array ("/&([a-zA-Z0-9]*[; \n])/", "/<!--(.*)-->/", "/<([^>]*)>/", "/\\[--/", "/--]/"),
        array ("[--span class=\"entity\"--]&amp;\\1[--/span--]", "[--span class=\"comment\"--]&lt;!--\\1--&gt;[--/span--]", "[--span class=\"tag\"--]&lt;\\1&gt;[--/span--]", "<", ">"), $t);
}

function cssColor ($t){
    return preg_replace (array ("/(\\/\\*.*\\*\\/)/", "/([-a-zA-Z0-9]*):([^;]*);/"),
        array ("<span class=\"comment\">\\1</span>", "<span class=\"tag\">\\1:</span><span class=\"param\">\\2;</span>"), $t);
}

function cgiColor ($t){
    return preg_replace (array ("/&([a-zA-Z0-9]*[; \n])/", "/<!--(.*)-->/", "/<([^>]*)>/", "/\\[--/", "/--]/"),
        array ("[--span class=\"entity\"--]&amp;\\1[--/span--]", "[--span class=\"comment\"--]&lt;!--\\1--&gt;[--/span--]", "[--span class=\"tag\"--]&lt;\\1&gt;[--/span--]", "<", ">"), $t);
}

function phpColor ($t){
    return preg_replace (array ("/&([a-zA-Z0-9]*[; \n])/", "/<!--(.*)-->/", "/<([^>]*)>/", "/\\[--/", "/--]/"),
        array ("[--span class=\"entity\"--]&amp;\\1[--/span--]", "[--span class=\"comment\"--]&lt;!--\\1--&gt;[--/span--]", "[--span class=\"tag\"--]&lt;\\1&gt;[--/span--]", "<", ">"), $t);
}

function beauty ($f) {
    $t=file_get_contents($f);

    if (preg_match("/[.]css$/", $f)) {
        $t=cssColor($t);
    } elseif (preg_match("/[.]html?$/", $f)) {
        $t=htmlColor($t);
    } elseif (preg_match("/[.]cgi$/", $f)) {
        $t=cgiColor($t);
    } elseif (preg_match("/[.]php$/", $f)) {
        $t=phpColor($t);
    } else {
      exec ("cat $f | c2html -sc", $output);
      $t = join($output, "\n");
    }

    $anchor="";
    if (array_key_exists("anchor", $_REQUEST)) {
      $anchor = "#$_REQUEST[anchor]";
    }

    $nome = preg_replace("|^../|", "", $f);
    $result  = "<!DOCTYPE html>\n";
    $result .= "<html>\n";
    $result .= "<title>Visualizzazione \"$nome\"</title>\n";
    $result .= "<link href=\"../css/index.css\" rel=\"stylesheet\" type=\"text/css\">\n";
    $result .= "</head>\n<body style=\"margin: 5px\">\n";
    $result .= "<h1>$nome</h1>\n";
    $result .= "<p>[<a href=\"../index.html$anchor\">Ritorna</a>]</p>\n<pre>\n";
    $result .= "<div class=\"display\">\n";
    $result .= $t;
    $result .= "</div>\n";
    $result .= "</pre>\n";
    $result .= "    <div id=\"footer\">\n";
    $result .= "      <span class=\"author\">Autore Stefano Salvi</span> <a href=\"mailto:stefano@salvi.mn.it\" title=\"Indirizzo Mail di Salvi\">stefano@salvi.mn.it</a>\n";
    $result .= "      Rilasciato su licenza <a href=\"https://creativecommons.org/licenses/by-sa/3.0/it/legalcode\" title=\"Attribuzione CC-by-sa\">CC-BY-SA</a><br>\n";
    $result .= "      <a href=\"https://creativecommons.org/licenses/by-sa/3.0/it/legalcode\" title=\"Attribuzione CC-by-sa\"><img src=\"img/cc_by_sa_88x31.png\" alt=\"Logo Creative Commons\" title=\"Logo Creative Commons\"></a>\n";
    $result .= "    </div>\n";
    $result .= "</body>\n</html>";

    return $result;
}
    $b = beauty ("$_REQUEST[file]");
    print $b;
?>
